// THIS LIB WAS INTEGRATED WITH THE PURPOSE TO WORK WITH HOLTEK 4xR01T3v130
// http://www.holtek.com/pdf/consumer/4xR01T3v130.pdf

// ONLY SNIFFING/RECEIVING OR SENDING IS ALLOWED FOR NOW
// SO USE THIS LIB IN ORDER TO ANALYSE YOUR PAKET STRUCTURE AND SEND SEPARATELY
#include "RxTx.h"
RxTx* rxtx;



void setup() 
{
/*
ATTENTION:
- You must specify the correct RX TX PINS SEE SPECIFICATION IN THE LIBRARY
- You must pay attention to the libraries maximum buffer size according to your uc's flash
*/

  
// 1. INIT THE RXTX LIB
  // INIT RXTX SIGNAL ANALYSER PIN RX , PIN TX, BUFFER SIZE
  rxtx = new RxTx(10, 11, 42*20);


// 2. SNIFF TRAFFIC @TX
  // SNIFF FOR INCOMMING PAKETS TO FIND OUT THE PAKETS SYNC PERIOD/BREAK AND TIMINGS
  // e.g. rxtx->Sniff();
  rxtx->Sniff();



// 3. MANUALLY LOOK IN THE RESULTS OF 2. FOR SYNC PAKETS (THEY ARE LARGE THEN ALL THE OTHERS)
// 3.1 SNIFF THE EXACT PAKETS BY SNIFFING WITH THE MONITORED SYNC DURATION FROM 2.
  // SNIFF WITH PAKETS PERIOD SIZE AND TIMINGS
  // FILTER PAKET STRUCTURE WITH SYNC PERIOD
  // e.g. HT480R1T3: rxtx->SniffEstimatedPaketSize(80000);
  // e.g. Vellemann security doors: rxtx->SniffEstimatedPaketSize(36000);



// 4. EXTRACT THE SPECIFIC PAKET RECEIVED IN 3.1 BY LOOKING FOR PROPER RANGES OF MIN/MAX TIMINGS THERE SHOULD BE 3 DIFFERENT STAGES LOW/HIGH/FINAL
  // FILTER PAKET STRUCTURE WITH COMPLETE REVERSED INFORMATION
  // SYNC_AVG, MIN_OF_MIN, MAX_OF_MIN, MIN_OF_MAX, MAX_OF_MAX, MIN_OF_SYNC, MAX_OF_SYNC
  // e.g. HT480R1T3: rxtx->SniffEstimatedPaketSize(83000, 600, 800, 1300, 1500, 75000, 85000);
  // e.g. Vellemann security doors: rxtx->SniffEstimatedPaketSize(36000, 200, 400, 500, 700, 35000, 40000); 



// 5. TAKE THE SIGNAL AND SEND IT... HF!
// 5.1 SEND Vellemann security doors...
  // OPEN
  //char* on_c = new char[67];
  //String on_s =  "SSLLSLSSLLSSLLSSLLSSLLSSLSLLSLSSLSLLSSLSLLSLSLSSLLSLSLSLSSLLSLSSLF";
  //on_s.toCharArray(on_c, 67);
  //rxtx->SendMessage(on_c, 600, 300, 36000, 4);
  
  //CLOSE
  //char* off_c = new char[67];
  //String off_s = "SSLLSLSSLLSSLLSSLLSSLLSSLSLLSLSSLSLLSSLSLLSLSLSSLLSLSLSLSSLLSSLLSF";
  //off_s.toCharArray(off_c, 67);
  //rxtx->SendMessage(off_c, 600, 300, 36000, 4);


// 5.2 SEND HT480R1T3...
  // ON "SLSSLLSLSLSLSLSLSLSLSLSLSSLSLSLLSSLSLSLLSF", duration L(ong) = 1400, duration S(hort) = 700, duration F(inal) = 81000, repeat count = 4
  //char* on_c = new char[43];
  //String on_s = "SLSSLLSLSLSLSLSLSLSLSLSLSSLSLSLLSSLSLSLLSF";
  //on_s.toCharArray(on_c, 43);
  //rxtx->SendMessage(on_c, 1400, 700, 81000, 4);
}



void loop() 
{
  // RECEIVER AND PRINTER (NECESSARY FOR DEBUGGING
  rxtx->Loop();
}

